// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/TotalHarmonicDistortion.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Electricity {

  /// <summary>Holder for reflection information generated from telemetry/TotalHarmonicDistortion.proto</summary>
  public static partial class TotalHarmonicDistortionReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/TotalHarmonicDistortion.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static TotalHarmonicDistortionReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Cid0ZWxlbWV0cnkvVG90YWxIYXJtb25pY0Rpc3RvcnRpb24ucHJvdG8SC2Vs",
            "ZWN0cmljaXR5IoMDChdUb3RhbEhhcm1vbmljRGlzdG9ydGlvbhIUCgdjdXJy",
            "ZW50GAEgASgJSACIAQESFAoHdm9sdGFnZRgCIAEoCUgBiAEBEkQKC3NhbXBs",
            "ZV90eXBlGBQgASgOMi8uZWxlY3RyaWNpdHkuVG90YWxIYXJtb25pY0Rpc3Rv",
            "cnRpb24uU2FtcGxlVHlwZRI5CgVwaGFzZRgVIAEoDjIqLmVsZWN0cmljaXR5",
            "LlRvdGFsSGFybW9uaWNEaXN0b3J0aW9uLlBoYXNlIicKClNhbXBsZVR5cGUS",
            "BwoDQVZHEAASBwoDTUlOEAESBwoDTUFYEAIiegoFUGhhc2USBgoCTDEQABIG",
            "CgJMMhABEgYKAkwzEAISCAoETDFfThADEggKBEwyX04QBBIICgRMM19OEAUS",
            "CAoEUEVfThAGEgUKAU4QBxIJCgVMMV9MMhAIEgkKBUwyX0wzEAkSCQoFTDNf",
            "TDEQChIJCgVUT1RBTBALQgoKCF9jdXJyZW50QgoKCF92b2x0YWdlQoMBChtj",
            "b20uY29kaWJseS5tb2RlbC50ZWxlbWV0cnlCHFRvdGFsSGFybW9uaWNEaXN0",
            "b3J0aW9uUHJvdG/KAhtEb21haW5Nb2RlbFxQcm90b1xUZWxlbWV0cnniAidE",
            "b21haW5Nb2RlbFxQcm90b1xUZWxlbWV0cnlcR1BCTWV0YWRhdGFiBnByb3Rv",
            "Mw=="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Electricity.TotalHarmonicDistortion), global::Electricity.TotalHarmonicDistortion.Parser, new[]{ "Current", "Voltage", "SampleType", "Phase" }, new[]{ "Current", "Voltage" }, new[]{ typeof(global::Electricity.TotalHarmonicDistortion.Types.SampleType), typeof(global::Electricity.TotalHarmonicDistortion.Types.Phase) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class TotalHarmonicDistortion : pb::IMessage<TotalHarmonicDistortion>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<TotalHarmonicDistortion> _parser = new pb::MessageParser<TotalHarmonicDistortion>(() => new TotalHarmonicDistortion());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<TotalHarmonicDistortion> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Electricity.TotalHarmonicDistortionReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public TotalHarmonicDistortion() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public TotalHarmonicDistortion(TotalHarmonicDistortion other) : this() {
      current_ = other.current_;
      voltage_ = other.voltage_;
      sampleType_ = other.sampleType_;
      phase_ = other.phase_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public TotalHarmonicDistortion Clone() {
      return new TotalHarmonicDistortion(this);
    }

    /// <summary>Field number for the "current" field.</summary>
    public const int CurrentFieldNumber = 1;
    private string current_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Current {
      get { return current_ ?? ""; }
      set {
        current_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "current" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCurrent {
      get { return current_ != null; }
    }
    /// <summary>Clears the value of the "current" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCurrent() {
      current_ = null;
    }

    /// <summary>Field number for the "voltage" field.</summary>
    public const int VoltageFieldNumber = 2;
    private string voltage_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Voltage {
      get { return voltage_ ?? ""; }
      set {
        voltage_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "voltage" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasVoltage {
      get { return voltage_ != null; }
    }
    /// <summary>Clears the value of the "voltage" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearVoltage() {
      voltage_ = null;
    }

    /// <summary>Field number for the "sample_type" field.</summary>
    public const int SampleTypeFieldNumber = 20;
    private global::Electricity.TotalHarmonicDistortion.Types.SampleType sampleType_ = global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.TotalHarmonicDistortion.Types.SampleType SampleType {
      get { return sampleType_; }
      set {
        sampleType_ = value;
      }
    }

    /// <summary>Field number for the "phase" field.</summary>
    public const int PhaseFieldNumber = 21;
    private global::Electricity.TotalHarmonicDistortion.Types.Phase phase_ = global::Electricity.TotalHarmonicDistortion.Types.Phase.L1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.TotalHarmonicDistortion.Types.Phase Phase {
      get { return phase_; }
      set {
        phase_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as TotalHarmonicDistortion);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(TotalHarmonicDistortion other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Current != other.Current) return false;
      if (Voltage != other.Voltage) return false;
      if (SampleType != other.SampleType) return false;
      if (Phase != other.Phase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasCurrent) hash ^= Current.GetHashCode();
      if (HasVoltage) hash ^= Voltage.GetHashCode();
      if (SampleType != global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg) hash ^= SampleType.GetHashCode();
      if (Phase != global::Electricity.TotalHarmonicDistortion.Types.Phase.L1) hash ^= Phase.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasCurrent) {
        output.WriteRawTag(10);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(18);
        output.WriteString(Voltage);
      }
      if (SampleType != global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.TotalHarmonicDistortion.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasCurrent) {
        output.WriteRawTag(10);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(18);
        output.WriteString(Voltage);
      }
      if (SampleType != global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.TotalHarmonicDistortion.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasCurrent) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Current);
      }
      if (HasVoltage) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Voltage);
      }
      if (SampleType != global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) SampleType);
      }
      if (Phase != global::Electricity.TotalHarmonicDistortion.Types.Phase.L1) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) Phase);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(TotalHarmonicDistortion other) {
      if (other == null) {
        return;
      }
      if (other.HasCurrent) {
        Current = other.Current;
      }
      if (other.HasVoltage) {
        Voltage = other.Voltage;
      }
      if (other.SampleType != global::Electricity.TotalHarmonicDistortion.Types.SampleType.Avg) {
        SampleType = other.SampleType;
      }
      if (other.Phase != global::Electricity.TotalHarmonicDistortion.Types.Phase.L1) {
        Phase = other.Phase;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            Current = input.ReadString();
            break;
          }
          case 18: {
            Voltage = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.TotalHarmonicDistortion.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.TotalHarmonicDistortion.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            Current = input.ReadString();
            break;
          }
          case 18: {
            Voltage = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.TotalHarmonicDistortion.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.TotalHarmonicDistortion.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the TotalHarmonicDistortion message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum SampleType {
        [pbr::OriginalName("AVG")] Avg = 0,
        [pbr::OriginalName("MIN")] Min = 1,
        [pbr::OriginalName("MAX")] Max = 2,
      }

      public enum Phase {
        [pbr::OriginalName("L1")] L1 = 0,
        [pbr::OriginalName("L2")] L2 = 1,
        [pbr::OriginalName("L3")] L3 = 2,
        [pbr::OriginalName("L1_N")] L1N = 3,
        [pbr::OriginalName("L2_N")] L2N = 4,
        [pbr::OriginalName("L3_N")] L3N = 5,
        [pbr::OriginalName("PE_N")] PeN = 6,
        [pbr::OriginalName("N")] N = 7,
        [pbr::OriginalName("L1_L2")] L1L2 = 8,
        [pbr::OriginalName("L2_L3")] L2L3 = 9,
        [pbr::OriginalName("L3_L1")] L3L1 = 10,
        [pbr::OriginalName("TOTAL")] Total = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
